/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.appkit.NSBrowserCell;

import dstep.appkit.NSCell;
import dstep.appkit.NSColor;
import dstep.appkit.NSImage;
import dstep.appkit.NSView;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSBrowserCell : NSCell
{
	mixin (ObjcWrap);

	static NSImage branchImage ()
	{
		return invokeObjcSelfClass!(NSImage, "branchImage");
	}

	static NSImage highlightedBranchImage ()
	{
		return invokeObjcSelfClass!(NSImage, "highlightedBranchImage");
	}

	NSColor highlightColorInView (NSView controlView)
	{
		return invokeObjcSelf!(NSColor, "highlightColorInView:", NSView)(controlView);
	}

	bool isLeaf ()
	{
		return invokeObjcSelf!(bool, "isLeaf");
	}

	void setLeaf (bool flag)
	{
		return invokeObjcSelf!(void, "setLeaf:", bool)(flag);
	}

	bool isLoaded ()
	{
		return invokeObjcSelf!(bool, "isLoaded");
	}

	void setLoaded (bool flag)
	{
		return invokeObjcSelf!(void, "setLoaded:", bool)(flag);
	}

	void reset ()
	{
		return invokeObjcSelf!(void, "reset");
	}

	void set ()
	{
		return invokeObjcSelf!(void, "set");
	}

	void setImage (NSImage image)
	{
		return invokeObjcSelf!(void, "setImage:", NSImage)(image);
	}

	NSImage image ()
	{
		return invokeObjcSelf!(NSImage, "image");
	}

	void setAlternateImage (NSImage newAltImage)
	{
		return invokeObjcSelf!(void, "setAlternateImage:", NSImage)(newAltImage);
	}

	NSImage alternateImage ()
	{
		return invokeObjcSelf!(NSImage, "alternateImage");
	}
}

