/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corevideo.CVOpenGLBufferPool;

import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFDictionary;
import dstep.corevideo.CVBase;
import dstep.corevideo.CVOpenGLBuffer;
import dstep.corevideo.CVReturn;

struct __CVOpenGLBufferPool;

alias __CVOpenGLBufferPool* CVOpenGLBufferPoolRef;

extern (C)
{
	extern
	{
		const CFStringRef kCVOpenGLBufferPoolMinimumBufferCountKey;
		const CFStringRef kCVOpenGLBufferPoolMaximumBufferAgeKey;
	}
}

extern (C)
{
	uint CVOpenGLBufferPoolGetTypeID ();
	CVOpenGLBufferPoolRef CVOpenGLBufferPoolRetain (CVOpenGLBufferPoolRef openGLBufferPool);
	void CVOpenGLBufferPoolRelease (CVOpenGLBufferPoolRef openGLBufferPool);
	int CVOpenGLBufferPoolCreate (CFAllocatorRef allocator, CFDictionaryRef poolAttributes, CFDictionaryRef openGLBufferAttributes, CVOpenGLBufferPoolRef* poolOut);
	CFDictionaryRef CVOpenGLBufferPoolGetAttributes (CVOpenGLBufferPoolRef pool);
	CFDictionaryRef CVOpenGLBufferPoolGetOpenGLBufferAttributes (CVOpenGLBufferPoolRef pool);
	int CVOpenGLBufferPoolCreateOpenGLBuffer (CFAllocatorRef allocator, CVOpenGLBufferPoolRef openGLBufferPool, CVOpenGLBufferRef* openGLBufferOut);
}