/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.corevideo.CVPixelBufferPool;

import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFDictionary;
import dstep.corevideo.CVBase;
import dstep.corevideo.CVPixelBuffer;
import dstep.corevideo.CVReturn;

struct __CVPixelBufferPool;

alias __CVPixelBufferPool* CVPixelBufferPoolRef;

extern (C)
{
	extern
	{
		const CFStringRef kCVPixelBufferPoolMinimumBufferCountKey;
		const CFStringRef kCVPixelBufferPoolMaximumBufferAgeKey;
	}
}

extern (C)
{
	uint CVPixelBufferPoolGetTypeID ();
	CVPixelBufferPoolRef CVPixelBufferPoolRetain (CVPixelBufferPoolRef pixelBufferPool);
	void CVPixelBufferPoolRelease (CVPixelBufferPoolRef pixelBufferPool);
	int CVPixelBufferPoolCreate (CFAllocatorRef allocator, CFDictionaryRef poolAttributes, CFDictionaryRef pixelBufferAttributes, CVPixelBufferPoolRef* poolOut);
	CFDictionaryRef CVPixelBufferPoolGetAttributes (CVPixelBufferPoolRef pool);
	CFDictionaryRef CVPixelBufferPoolGetPixelBufferAttributes (CVPixelBufferPoolRef pool);
	int CVPixelBufferPoolCreatePixelBuffer (CFAllocatorRef allocator, CVPixelBufferPoolRef pixelBufferPool, CVPixelBufferRef* pixelBufferOut);
}