/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSHost;

import dstep.foundation.NSArray;
import dstep.foundation.NSObject;
import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSHost : NSObject
{
	mixin (ObjcWrap);
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	static NSHost currentHost ()
	{
		return invokeObjcSuperClass!(NSHost, "currentHost");
	}

	static NSHost hostWithName (NSString name)
	{
		return invokeObjcSuperClass!(NSHost, "hostWithName:", NSString)(name);
	}

	static NSHost hostWithAddress (NSString address)
	{
		return invokeObjcSuperClass!(NSHost, "hostWithAddress:", NSString)(address);
	}

	static void setHostCacheEnabled (bool flag)
	{
		return invokeObjcSuperClass!(void, "setHostCacheEnabled:", bool)(flag);
	}

	static bool isHostCacheEnabled ()
	{
		return invokeObjcSuperClass!(bool, "isHostCacheEnabled");
	}

	static void flushHostCache ()
	{
		return invokeObjcSuperClass!(void, "flushHostCache");
	}

	bool isEqualToHost (NSHost aHost)
	{
		return invokeObjcSelf!(bool, "isEqualToHost:", NSHost)(aHost);
	}

	NSString name ()
	{
		return invokeObjcSelf!(NSString, "name");
	}

	NSArray names ()
	{
		return invokeObjcSelf!(NSArray, "names");
	}

	NSString address ()
	{
		return invokeObjcSelf!(NSString, "address");
	}

	NSArray addresses ()
	{
		return invokeObjcSelf!(NSArray, "addresses");
	}
}

