/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSPortCoder;

import dstep.foundation.NSArray;
import dstep.foundation.NSCoder;
import dstep.foundation.NSConnection;
import dstep.foundation.NSPort;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

const TNSDistributedObjects = `

	Class classForPortCoder ()
	{
		return invokeObjcSelf!(Class, "classForPortCoder");
	}
	
	Object replacementObjectForPortCoder (NSPortCoder coder)
	{
		return invokeObjcSelf!(Object, "replacementObjectForPortCoder:", NSPortCoder)(coder);
	}
	
	//mixin ObjcBindMethod!(classForPortCoder, "classForPortCoder");
	//mixin ObjcBindMethod!(replacementObjectForPortCoder, "replacementObjectForPortCoder:");
`;

class NSPortCoder : NSCoder
{
	mixin (ObjcWrap);
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	bool isBycopy ()
	{
		return invokeObjcSelf!(bool, "isBycopy");
	}

	bool isByref ()
	{
		return invokeObjcSelf!(bool, "isByref");
	}

	NSConnection connection ()
	{
		return invokeObjcSelf!(NSConnection, "connection");
	}

	void encodePortObject (NSPort aport)
	{
		return invokeObjcSelf!(void, "encodePortObject:", NSPort)(aport);
	}

	NSPort decodePortObject ()
	{
		return invokeObjcSelf!(NSPort, "decodePortObject");
	}

	static Object portCoderWithReceivePort (NSPort rcvPort, NSPort sndPort, NSArray comps)
	{
		return invokeObjcSuperClass!(Object, "portCoderWithReceivePort:sendPort:components:", NSPort, NSPort, NSArray)(rcvPort, sndPort, comps);
	}

	Object initWithReceivePort (NSPort rcvPort, NSPort sndPort, NSArray comps)
	{
		return invokeObjcSelf!(Object, "initWithReceivePort:sendPort:components:", NSPort, NSPort, NSArray)(rcvPort, sndPort, comps);
	}

	this (NSPort rcvPort, NSPort sndPort, NSArray comps)
	{
		typeof(this).alloc.initWithReceivePort(rcvPort, sndPort, comps);
	}

	void dispatch ()
	{
		return invokeObjcSelf!(void, "dispatch");
	}
}