/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSPortMessage;

import dstep.foundation.NSArray;
import dstep.foundation.NSDate;
import dstep.foundation.NSObject;
import dstep.foundation.NSPort;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSPortMessage : NSObject
{
	mixin (ObjcWrap);
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}

	Object initWithSendPort (NSPort sendPort, NSPort replyPort, NSArray components)
	{
		return invokeObjcSelf!(Object, "initWithSendPort:receivePort:components:", NSPort, NSPort, NSArray)(sendPort, replyPort, components);
	}

	this (NSPort sendPort, NSPort replyPort, NSArray components)
	{
		typeof(this).alloc.initWithSendPort(sendPort, replyPort, components);
	}

	NSArray components ()
	{
		return invokeObjcSelf!(NSArray, "components");
	}

	NSPort receivePort ()
	{
		return invokeObjcSelf!(NSPort, "receivePort");
	}

	NSPort sendPort ()
	{
		return invokeObjcSelf!(NSPort, "sendPort");
	}

	bool sendBeforeDate (NSDate date)
	{
		return invokeObjcSelf!(bool, "sendBeforeDate:", NSDate)(date);
	}

	uint msgid ()
	{
		return invokeObjcSelf!(uint, "msgid");
	}

	void setMsgid (uint msgid)
	{
		return invokeObjcSelf!(void, "setMsgid:", uint)(msgid);
	}
}

