/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSScriptCommandDescription;

import dstep.foundation.NSArray;
import dstep.foundation.NSCoder;
import dstep.foundation.NSDictionary;
import dstep.foundation.NSObject;
import dstep.foundation.NSScriptCommand;
import dstep.foundation.NSString;
import dstep.foundation.NSZone;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

class NSScriptCommandDescription : NSObject, INSCoding
{
	mixin (ObjcWrap);	
	
	this ()
	{
		super(typeof(this).alloc.init.objcObject);
	}
	
	typeof(this) init ()
	{
		return invokeObjcSelf!(typeof(this), "init");
	}
	
	Object initWithSuiteName (NSString suiteName, NSString commandName, NSDictionary commandDeclaration)
	{
		return invokeObjcSelf!(Object, "initWithSuiteName:commandName:dictionary:", NSString, NSString, NSDictionary)(suiteName, commandName, commandDeclaration);
	}

	this (NSString suiteName, NSString commandName, NSDictionary commandDeclaration)
	{
		typeof(this).alloc.initWithSuiteName(suiteName, commandName, commandDeclaration);
	}

	NSString suiteName ()
	{
		return invokeObjcSelf!(NSString, "suiteName");
	}

	NSString commandName ()
	{
		return invokeObjcSelf!(NSString, "commandName");
	}

	uint appleEventClassCode ()
	{
		return invokeObjcSelf!(uint, "appleEventClassCode");
	}

	uint appleEventCode ()
	{
		return invokeObjcSelf!(uint, "appleEventCode");
	}

	NSString commandClassName ()
	{
		return invokeObjcSelf!(NSString, "commandClassName");
	}

	NSString returnType ()
	{
		return invokeObjcSelf!(NSString, "returnType");
	}

	uint appleEventCodeForReturnType ()
	{
		return invokeObjcSelf!(uint, "appleEventCodeForReturnType");
	}

	NSArray argumentNames ()
	{
		return invokeObjcSelf!(NSArray, "argumentNames");
	}

	NSString typeForArgumentWithName (NSString argumentName)
	{
		return invokeObjcSelf!(NSString, "typeForArgumentWithName:", NSString)(argumentName);
	}

	uint appleEventCodeForArgumentWithName (NSString argumentName)
	{
		return invokeObjcSelf!(uint, "appleEventCodeForArgumentWithName:", NSString)(argumentName);
	}

	bool isOptionalArgumentWithName (NSString argumentName)
	{
		return invokeObjcSelf!(bool, "isOptionalArgumentWithName:", NSString)(argumentName);
	}

	NSScriptCommand createCommandInstance ()
	{
		return invokeObjcSelf!(NSScriptCommand, "createCommandInstance");
	}

	NSScriptCommand createCommandInstanceWithZone (NSZone* zone)
	{
		return invokeObjcSelf!(NSScriptCommand, "createCommandInstanceWithZone:", NSZone*)(zone);
	}

	void encodeWithCoder (NSCoder aCoder)
	{
		return invokeObjcSelf!(void, "encodeWithCoder:", NSCoder)(aCoder);
	}

	Object initWithCoder (NSCoder aDecoder)
	{
		return invokeObjcSelf!(Object, "initWithCoder:", NSCoder)(aDecoder);
	}

	this (NSCoder aDecoder)
	{
		typeof(this).alloc.initWithCoder(aDecoder);
	}
}

