/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Aug 3, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.foundation.NSURLError;

import dstep.foundation.NSString;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;
import bindings = dstep.foundation.NSURLError_bindings;

private
{
	NSString NSURLErrorDomain_;
	NSString NSErrorFailingURLStringKey_;
}

NSString NSURLErrorDomain ()
{
	if (NSURLErrorDomain_)
		return NSURLErrorDomain_;
		
	return NSURLErrorDomain_ = new NSString(bindings.NSURLErrorDomain);
}

NSString NSErrorFailingURLStringKey ()
{
	if (NSErrorFailingURLStringKey_)
		return NSErrorFailingURLStringKey_;
		
	return NSErrorFailingURLStringKey_ = new NSString(bindings.NSErrorFailingURLStringKey);
}

enum
{
	NSURLErrorUnknown = -1,
	NSURLErrorCancelled = -999,
	NSURLErrorBadURL = -1000,
	NSURLErrorTimedOut = -1001,
	NSURLErrorUnsupportedURL = -1002,
	NSURLErrorCannotFindHost = -1003,
	NSURLErrorCannotConnectToHost = -1004,
	NSURLErrorNetworkConnectionLost = -1005,
	NSURLErrorDNSLookupFailed = -1006,
	NSURLErrorHTTPTooManyRedirects = -1007,
	NSURLErrorResourceUnavailable = -1008,
	NSURLErrorNotConnectedToInternet = -1009,
	NSURLErrorRedirectToNonExistentLocation = -1010,
	NSURLErrorBadServerResponse = -1011,
	NSURLErrorUserCancelledAuthentication = -1012,
	NSURLErrorUserAuthenticationRequired = -1013,
	NSURLErrorZeroByteResource = -1014,
	NSURLErrorCannotDecodeRawData = -1015,
	NSURLErrorCannotDecodeContentData = -1016,
	NSURLErrorCannotParseResponse = -1017,
	NSURLErrorFileDoesNotExist = -1100,
	NSURLErrorFileIsDirectory = -1101,
	NSURLErrorNoPermissionsToReadFile = -1102,
	NSURLErrorDataLengthExceedsMaximum = -1103,
	NSURLErrorSecureConnectionFailed = -1200,
	NSURLErrorServerCertificateHasBadDate = -1201,
	NSURLErrorServerCertificateUntrusted = -1202,
	NSURLErrorServerCertificateHasUnknownRoot = -1203,
	NSURLErrorServerCertificateNotYetValid = -1204,
	NSURLErrorClientCertificateRejected = -1205,
	NSURLErrorCannotLoadFromNetwork = -2000,
	NSURLErrorCannotCreateFile = -3000,
	NSURLErrorCannotOpenFile = -3001,
	NSURLErrorCannotCloseFile = -3002,
	NSURLErrorCannotWriteToFile = -3003,
	NSURLErrorCannotRemoveFile = -3004,
	NSURLErrorCannotMoveFile = -3005,
	NSURLErrorDownloadDecodingFailedMidStream = -3006,
	NSURLErrorDownloadDecodingFailedToComplete = -3007
}