/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CIRAWFilter;

import dstep.foundation.NSData;
import dstep.foundation.NSDictionary;
import dstep.foundation.NSString;
import dstep.foundation.NSURL;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

import bindings = dstep.quartzcore.CIRAWFilter_bindings;

private
{
	NSString kCIInputDecoderVersionKey_;
	NSString kCISupportedDecoderVersionsKey_;
	NSString kCIInputBoostKey_;
	NSString kCIInputNeutralChromaticityXKey_;
	NSString kCIInputNeutralChromaticityYKey_;
	NSString kCIInputNeutralTemperatureKey_;
	NSString kCIInputNeutralTintKey_;
	NSString kCIInputNeutralLocationKey_;
	NSString kCIInputScaleFactorKey_;
	NSString kCIInputAllowDraftModeKey_;
	NSString kCIInputIgnoreImageOrientationKey_;
	NSString kCIInputImageOrientationKey_;
	NSString kCIInputEnableSharpeningKey_;
	NSString kCIInputEnableChromaticNoiseTrackingKey_;
	NSString kCIInputBoostShadowAmountKey_;
	NSString kCIInputBiasKey_;
}

NSString kCIInputDecoderVersionKey ()
{
	if (kCIInputDecoderVersionKey_)
		return kCIInputDecoderVersionKey_;

	return kCIInputDecoderVersionKey_ = new NSString(bindings.kCIInputDecoderVersionKey);
}

NSString kCISupportedDecoderVersionsKey ()
{
	if (kCISupportedDecoderVersionsKey_)
		return kCISupportedDecoderVersionsKey_;

	return kCISupportedDecoderVersionsKey_ = new NSString(bindings.kCISupportedDecoderVersionsKey);
}

NSString kCIInputBoostKey ()
{
	if (kCIInputBoostKey_)
		return kCIInputBoostKey_;

	return kCIInputBoostKey_ = new NSString(bindings.kCIInputBoostKey);
}

NSString kCIInputNeutralChromaticityXKey ()
{
	if (kCIInputNeutralChromaticityXKey_)
		return kCIInputNeutralChromaticityXKey_;

	return kCIInputNeutralChromaticityXKey_ = new NSString(bindings.kCIInputNeutralChromaticityXKey);
}

NSString kCIInputNeutralChromaticityYKey ()
{
	if (kCIInputNeutralChromaticityYKey_)
		return kCIInputNeutralChromaticityYKey_;

	return kCIInputNeutralChromaticityYKey_ = new NSString(bindings.kCIInputNeutralChromaticityYKey);
}

NSString kCIInputNeutralTemperatureKey ()
{
	if (kCIInputNeutralTemperatureKey_)
		return kCIInputNeutralTemperatureKey_;

	return kCIInputNeutralTemperatureKey_ = new NSString(bindings.kCIInputNeutralTemperatureKey);
}

NSString kCIInputNeutralTintKey ()
{
	if (kCIInputNeutralTintKey_)
		return kCIInputNeutralTintKey_;

	return kCIInputNeutralTintKey_ = new NSString(bindings.kCIInputNeutralTintKey);
}

NSString kCIInputNeutralLocationKey ()
{
	if (kCIInputNeutralLocationKey_)
		return kCIInputNeutralLocationKey_;

	return kCIInputNeutralLocationKey_ = new NSString(bindings.kCIInputNeutralLocationKey);
}

NSString kCIInputScaleFactorKey ()
{
	if (kCIInputScaleFactorKey_)
		return kCIInputScaleFactorKey_;

	return kCIInputScaleFactorKey_ = new NSString(bindings.kCIInputScaleFactorKey);
}

NSString kCIInputAllowDraftModeKey ()
{
	if (kCIInputAllowDraftModeKey_)
		return kCIInputAllowDraftModeKey_;

	return kCIInputAllowDraftModeKey_ = new NSString(bindings.kCIInputAllowDraftModeKey);
}

NSString kCIInputIgnoreImageOrientationKey ()
{
	if (kCIInputIgnoreImageOrientationKey_)
		return kCIInputIgnoreImageOrientationKey_;

	return kCIInputIgnoreImageOrientationKey_ = new NSString(bindings.kCIInputIgnoreImageOrientationKey);
}

NSString kCIInputImageOrientationKey ()
{
	if (kCIInputImageOrientationKey_)
		return kCIInputImageOrientationKey_;

	return kCIInputImageOrientationKey_ = new NSString(bindings.kCIInputImageOrientationKey);
}

NSString kCIInputEnableSharpeningKey ()
{
	if (kCIInputEnableSharpeningKey_)
		return kCIInputEnableSharpeningKey_;

	return kCIInputEnableSharpeningKey_ = new NSString(bindings.kCIInputEnableSharpeningKey);
}

NSString kCIInputEnableChromaticNoiseTrackingKey ()
{
	if (kCIInputEnableChromaticNoiseTrackingKey_)
		return kCIInputEnableChromaticNoiseTrackingKey_;

	return kCIInputEnableChromaticNoiseTrackingKey_ = new NSString(bindings.kCIInputEnableChromaticNoiseTrackingKey);
}

NSString kCIInputBoostShadowAmountKey ()
{
	if (kCIInputBoostShadowAmountKey_)
		return kCIInputBoostShadowAmountKey_;

	return kCIInputBoostShadowAmountKey_ = new NSString(bindings.kCIInputBoostShadowAmountKey);
}

NSString kCIInputBiasKey ()
{
	if (kCIInputBiasKey_)
		return kCIInputBiasKey_;

	return kCIInputBiasKey_ = new NSString(bindings.kCIInputBiasKey);
}

const TCIRAWFilter = `

	static CIFilter filterWithImageURL (NSURL url, NSDictionary options)
	{
		return invokeObjcSelfClass!(CIFilter, "filterWithImageURL:options:", NSURL, NSDictionary)(url, options);
	}

	static CIFilter filterWithImageData (NSData data, NSDictionary options)
	{
		return invokeObjcSelfClass!(CIFilter, "filterWithImageData:options:", NSData, NSDictionary)(data, options);
	}

	//mixin ObjcBindClassMethod!(filterWithImageURL, "filterWithImageURL:options:");
	//mixin ObjcBindClassMethod!(filterWithImageData, "filterWithImageData:options:");

`;

