/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Sep 24, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.quartzcore.CVOpenGLTextureCache;

import dstep.corefoundation.CFBase;
import dstep.corefoundation.CFDictionary;
import dstep.corevideo.CVImageBuffer;
import dstep.corevideo.CVOpenGLTexture;
import dstep.corevideo.CVOpenGLTextureCache;
import dstep.opengl.CGLTypes;
import dstep.objc.bridge.Bridge;
import dstep.objc.objc;

//import bindings = dstep.quartzcore.CVOpenGLTextureCache_bindings;

alias __CVOpenGLTextureCache* CVOpenGLTextureCacheRef;

extern (C)
{
	extern
	{
		const CFStringRef kCVOpenGLTextureCacheChromaSamplingModeKey;
		const CFStringRef kCVOpenGLTextureCacheChromaSamplingModeAutomatic;
		const CFStringRef kCVOpenGLTextureCacheChromaSamplingModeHighestQuality;
		const CFStringRef kCVOpenGLTextureCacheChromaSamplingModeBestPerformance;
	}
}

extern (C)
{
	uint CVOpenGLTextureCacheGetTypeID ();
	CVOpenGLTextureCacheRef CVOpenGLTextureCacheRetain (CVOpenGLTextureCacheRef textureCache);
	void CVOpenGLTextureCacheRelease (CVOpenGLTextureCacheRef textureCache);
	int CVOpenGLTextureCacheCreate (CFAllocatorRef allocator, CFDictionaryRef cacheAttributes, CGLContextObj cglContext, CGLPixelFormatObj cglPixelFormat, CFDictionaryRef textureAttributes, CVOpenGLTextureCacheRef* cacheOut);
	int CVOpenGLTextureCacheCreateTextureFromImage (CFAllocatorRef allocator, CVOpenGLTextureCacheRef textureCache, CVImageBufferRef sourceImage, CFDictionaryRef attributes, CVOpenGLTextureRef* textureOut);
	void CVOpenGLTextureCacheFlush (CVOpenGLTextureCacheRef textureCache, ulong options);
}