/**
 * Copyright: Copyright (c) 2009 Jacob Carlborg.
 * Authors: Jacob Carlborg
 * Version: Initial created: Jul 22, 2009 
 * License: $(LINK2 http://www.boost.org/LICENSE_1_0.txt, Boost Software License 1.0)
 */
module dstep.security.SecTrust;

import dstep.corefoundation.CoreFoundation;
import dstep.coreservices.carboncore.MacTypes : OSStatus;
import dstep.security.SecBase;
import dstep.security.cssmapple;
import dstep.security.cssmtype;

alias int SecTrustUserSetting;
alias OpaqueSecTrustRef* SecTrustRef;

enum SecTrustResultType
{
	kSecTrustResultInvalid,
	kSecTrustResultProceed,
	kSecTrustResultConfirm,
	kSecTrustResultDeny,
	kSecTrustResultUnspecified,
	kSecTrustResultRecoverableTrustFailure,
	kSecTrustResultFatalTrustFailure,
	kSecTrustResultOtherError
}

extern (C)
{
	uint SecTrustGetTypeID ();
	int SecTrustCreateWithCertificates (CFArrayRef certificates, CFTypeRef policies, SecTrustRef* trustRef);
	int SecTrustSetPolicies (SecTrustRef trust, CFTypeRef policies);
	int SecTrustSetParameters (SecTrustRef trustRef, uint action, CFDataRef actionData);
	int SecTrustSetAnchorCertificates (SecTrustRef trust, CFArrayRef anchorCertificates);
	int SecTrustSetKeychains (SecTrustRef trust, CFTypeRef keychainOrArray);
	int SecTrustSetVerifyDate (SecTrustRef trust, CFDateRef verifyDate);
	int SecTrustEvaluate (SecTrustRef trust, SecTrustResultType* result);
	int SecTrustGetResult (SecTrustRef trustRef, SecTrustResultType* result, CFArrayRef* certChain, CSSM_TP_APPLE_EVIDENCE_INFO** statusChain);
	int SecTrustGetCssmResult (SecTrustRef trust, CSSM_TP_VERIFY_CONTEXT_RESULT_PTR* result);
	int SecTrustGetCssmResultCode (SecTrustRef trust, OSStatus* resultCode);
	int SecTrustGetTPHandle (SecTrustRef trust, CSSM_TP_HANDLE* handle);
	int SecTrustCopyPolicies (SecTrustRef trust, CFArrayRef* policies);
	int SecTrustCopyCustomAnchorCertificates (SecTrustRef trust, CFArrayRef* anchors);
	int SecTrustCopyAnchorCertificates (CFArrayRef* anchors);
	int SecTrustGetCSSMAnchorCertificates (CSSM_DATA** cssmAnchors, uint* cssmAnchorCount);
	int SecTrustGetUserTrust (SecCertificateRef certificate, SecPolicyRef policy, SecTrustUserSetting* trustSetting);
	int SecTrustSetUserTrust (SecCertificateRef certificate, SecPolicyRef policy, int trustSetting);
}